; ###########################################################
; builder.asm            GoAsm build.bat Creator
; 5/13/2009                Written by Travis M
; ###########################################################

#include IncludeA\Windows.inc
#include headers\winbase.h
#include headers\winuser.h
#include headers\shellapi.h

#define WIN32_LEAN_AND_MEAN

; ###########################################################

DATA SECTION

; -----------------------------------------------------------
; Handle Variables
; -----------------------------------------------------------
WriteBuffer    db   300 dup (?)
hInstance      dd   ?
icoHandle      dd   ?
SearchHandle   dd   ?
batHandle      dd   0
bCount         dd   0
rChecked       dd   0

; -----------------------------------------------------------
; Directory Variables
; -----------------------------------------------------------
CurrentDir     db 251 dup (?)
dCount         dd          ?
FData          WIN32_FIND_DATA <?>


AsmFileName    db 25 dup (?)
RcFileName     db 25 dup (?)
objName        db 30 dup (?)
batDlls        db 50 dup (?)
rcRes          db 25 dup (?)
goasmPath      db 50 dup (?)

; -----------------------------------------------------------
; File Extensions used
; -----------------------------------------------------------

objExt         db ".obj ",0
resExt         db ".RES",0
AsmSearch      db "*.asm",0
RcSearch       db "*.rc",0
CRLF           db 13,10,0

; -----------------------------------------------------------
; Message Box Texts
; -----------------------------------------------------------

dllDefaults    db "kernel32.dll user32.dll",0
szAboutTitle   db "About",0
szAboutMsg     db "GoAsm Builder",10,13
               db "Created by Travis Montoya",10,13,10,13
               db "Simply creates a build.bat file based on the files",10,13
               db "in the current working directory. For best results",10,13
               db "make sure you have atleast a .asm file in the ",10,13
               db "current directory.",10,13,10,13
               db "Assembled with GoAsm 0.56.4e",0

szErrorTitle   db "Error",0
szErrorMsg     db "An error has occured. Sorry!",0

szDoneTitle    db "Finished",0
szDoneMsg      db "Finished creating build.bat",0  

; -----------------------------------------------------------
; Text for the bat file
; -----------------------------------------------------------

batFile        db "build.bat",0
batEcho        db "@echo off",0
batIfExist1    db "if not exist ",0
batIfExist2    db " goto norc",0
batGoRc        db "GoRc /r ",0
batGoAsm       db "GoAsm /fo ",0
batGoLink      db "GoLink ",0
batNoRc        db ":norc",0

CONST SECTION

; -----------------------------------------------------------
; Constants for our dialog
; -----------------------------------------------------------

BuilderDialog           equ 1000
IDC_STC1                equ 1001
IDC_OUTNAME             equ 1002
IDC_STC2                equ 1003
IDC_DLLS                equ 1004
IDC_RUNBUILD            equ 1005
IDC_BTNBUILD            equ 1006
IDC_ABOUT               equ 1007
IDC_BTN1                equ 1008

ConfigDialog            equ 1100
IDC_STC3                equ 1101
IDC_GOASMPATH           equ 1102
IDC_BTNSAVE             equ 1103
IDC_CANCEL              equ 1104
IDI_MAINICO             equ 100

; ###########################################################

CODE SECTION
start:
      invoke GetModuleHandle,0
      mov [hInstance],eax
      
      invoke LoadIcon,[hInstance],IDI_MAINICO
      mov [icoHandle],eax

      invoke DialogBoxParam,[hInstance],BuilderDialog,0,addr DlgProc,0
      invoke ExitProcess,eax

; ###########################################################

DlgProc FRAME hWnd,uMsg,wParam,lParam

      cmp d[uMsg],WM_CLOSE
      jne >WMINIT
      
      invoke EndDialog,[hWnd],0
      jmp >true
WMINIT:
      cmp d[uMsg],WM_INITDIALOG
      jne >WMCMD

      ; -----------------------------------------------------
      ; Set the initial DLL's that are most commonly linked
      ; -----------------------------------------------------
      
      invoke SetDlgItemText,[hWnd],IDC_DLLS,addr dllDefaults
      invoke SendMessage,[hWnd],WM_SETICON,ICON_SMALL,[icoHandle]
      jmp >true
WMCMD:
      cmp d[uMsg],WM_COMMAND
      jne >true


      cmp d[wParam],IDC_RUNBUILD
      je >CTEST

      
      cmp d[wParam],IDC_BTNBUILD
      je >BUILD

      cmp d[wParam],IDC_BTN1
      je >CONFIG

      cmp d[wParam],IDC_ABOUT
      je >DABOUT
      jne >false
CTEST:
      cmp d[rChecked],0
      je >make1

      mov d[rChecked],0
      jmp >true
make1:
      mov d[rChecked],1
      jmp >true
CONFIG:
      ; -----------------------------------------------------
      ; Display the configuration dialog
      ; ----------------------------------------------------- 
      
      invoke GetModuleHandle,0
      invoke DialogBoxParam,eax,ConfigDialog,0,addr ConfigProc,0
      jmp >true
DABOUT:
      ; -----------------------------------------------------
      ; Display our About message
      ; ----------------------------------------------------- 
      
      invoke MessageBoxEx,[hWnd],addr szAboutMsg,addr szAboutTitle,MB_ICONINFORMATION,NULL
      jmp >true
BUILD:
      ; -----------------------------------------------------
      ; Jump to start finding files
      ; -----------------------------------------------------
      
      jmp GetAssemblyFiles
      jmp >true
ERROR:
      invoke MessageBoxEx,[hWnd],addr szErrorMsg,addr szErrorTitle,MB_ICONERROR,NULL
      jmp >true
true:
      xor eax,eax
      ret
false:
      mov eax,1
      ret

; ###########################################################
GetAssemblyFiles:
      ; -----------------------------------------------------
      ; Find the assembly file
      ; -----------------------------------------------------
      
      invoke FindFirstFile,addr AsmSearch,addr FData
      cmp eax,INVALID_HANDLE_VALUE
      je ERROR

      mov [SearchHandle],eax

      invoke lstrcpy,addr AsmFileName,addr FData.cFileName
findNext:
      invoke FindNextFile,[SearchHandle],addr FData
      cmp eax,0
      je >GetRcFile

      invoke lstrcat,addr AsmFileName,addr " "
      invoke lstrcat,addr AsmFileName,addr FData.cFileName
      jmp findNext
GetRcFile:
      ; -----------------------------------------------------
      ; Find the RC FIle
      ; -----------------------------------------------------
      
      invoke FindFirstFile,addr RcSearch,addr FData
      cmp eax,INVALID_HANDLE_VALUE
      je >AsmDone

      invoke lstrcpy,addr RcFileName,addr FData.cFileName
      invoke CloseHandle,[SearchHandle]
      jmp >AsmDone
AsmDone:
      jmp >WriteBatFile

; ###########################################################

WriteBatFile:
      ; -----------------------------------------------------
      ; Finished finding the files now write the bat file
      ; -----------------------------------------------------
      
      invoke CreateFile,addr batFile,GENERIC_WRITE,FILE_SHARE_WRITE,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL

      cmp eax,INVALID_HANDLE_VALUE
      je ERROR

      mov [batHandle],eax

      invoke GetDlgItemText,[hWnd],IDC_DLLS,addr batDlls,250
      invoke GetDlgItemText,[hWnd],IDC_OUTNAME,addr objName,25
      invoke lstrcpy,addr rcRes,addr objName
      invoke lstrcat,addr objName,addr objExt

      ; -----------------------------------------------------
      ; Now lets format and put all our text in a buffer
      ; -----------------------------------------------------
      
      invoke lstrcat,addr WriteBuffer,addr batEcho
      invoke lstrcat,addr WriteBuffer,addr CRLF
      invoke lstrcat,addr WriteBuffer,addr CRLF
      invoke lstrcat,addr WriteBuffer,addr batIfExist1
      invoke lstrcat,addr WriteBuffer,addr RcFileName
      invoke lstrcat,addr WriteBuffer,addr batIfExist2
      invoke lstrcat,addr WriteBuffer,addr CRLF
      invoke lstrcat,addr WriteBuffer,addr CRLF
      invoke lstrcat,addr WriteBuffer,addr goasmPath
      invoke lstrcat,addr WriteBuffer,addr batGoRc
      invoke lstrcat,addr WriteBuffer,addr RcFileName
      invoke lstrcat,addr WriteBuffer,addr CRLF
      invoke lstrcat,addr WriteBuffer,addr goasmPath
      invoke lstrcat,addr WriteBuffer,addr batGoAsm
      invoke lstrcat,addr WriteBuffer,addr objName
      invoke lstrcat,addr WriteBuffer,addr AsmFileName
      invoke lstrcat,addr WriteBuffer,addr CRLF
      invoke lstrcat,addr WriteBuffer,addr goasmPath
      invoke lstrcat,addr WriteBuffer,addr batGoLink
      invoke lstrcat,addr WriteBuffer,addr batDlls
      invoke lstrcat,addr WriteBuffer,addr " "
      invoke lstrcat,addr WriteBuffer,addr objName
      invoke lstrcat,addr WriteBuffer,addr rcRes
      invoke lstrcat,addr WriteBuffer,addr resExt
      invoke lstrcat,addr WriteBuffer,addr CRLF
      invoke lstrcat,addr WriteBuffer,addr CRLF
      invoke lstrcat,addr WriteBuffer,addr batNoRc
      invoke lstrcat,addr WriteBuffer,addr CRLF
      invoke lstrcat,addr WriteBuffer,addr goasmPath
      invoke lstrcat,addr WriteBuffer,addr batGoAsm
      invoke lstrcat,addr WriteBuffer,addr objName
      invoke lstrcat,addr WriteBuffer,addr AsmFileName
      invoke lstrcat,addr WriteBuffer,addr CRLF
      invoke lstrcat,addr WriteBuffer,addr goasmPath
      invoke lstrcat,addr WriteBuffer,addr batGoLink
      invoke lstrcat,addr WriteBuffer,addr batDlls
      invoke lstrcat,addr WriteBuffer,addr " "
      invoke lstrcat,addr WriteBuffer,addr objName
      invoke lstrcat,addr WriteBuffer,addr rcRes
      invoke lstrcat,addr WriteBuffer,addr resExt

      ; -----------------------------------------------------
      ; Now lets write the bat file
      ; -----------------------------------------------------
      
      invoke lstrlen,addr WriteBuffer
      invoke WriteFile,[batHandle],addr WriteBuffer,eax,addr bCount,0
      invoke CloseHandle,[batHandle]

      ; -----------------------------------------------------
      ; Finished lets say we are done
      ; -----------------------------------------------------
      
      invoke MessageBoxEx,[hWnd],addr szDoneMsg,addr szDoneTitle,MB_ICONINFORMATION,NULL
      cmp d[rChecked],1
      jne true

      invoke ShellExecute,[hWnd],addr "open",addr batFile,NULL,NULL,SW_SHOWNORMAL
      jmp true
endf

; ###########################################################

ConfigProc FRAME hWnd,uMsg,wParam,lParam
      cmp d[uMsg],WM_INITDIALOG
      jne >WMCCMD

      ; -----------------------------------------------------
      ; Set the icon again
      ; -----------------------------------------------------
      
      invoke SendMessage,[hWnd],WM_SETICON,ICON_SMALL,[icoHandle]
      jmp >ctrue

WMCCMD:
      cmp d[uMsg],WM_COMMAND
      jne >WMCLOSE

      cmp d[wParam],IDC_CANCEL
      je >close

      cmp d[wParam],IDC_BTNSAVE
      jne >cfalse
      
      ; -----------------------------------------------------
      ; Save the text the user entered and exit
      ; -----------------------------------------------------
      
      invoke GetDlgItemText,[hWnd],IDC_GOASMPATH,addr goasmPath,250
      jmp >close
WMCLOSE:
      cmp d[uMsg],WM_CLOSE
      jne >ctrue
close:
      invoke EndDialog,[hWnd],0
      jmp >ctrue
      
 ctrue:
 xor eax,eax
 ret
 cfalse:
 mov eax,1
 ret
endf

; ###########################################################

